# coding: utf-8
"""general colors"""

FONT_NAME = "Textbook New"
COLORS = ["#F64A34",  # red
          "#FECB2F",  # yellow
          "#3C7ABC",  # blue
          "#91D34B",  # green
          "#FC8B2C",  # orange
          "#75C3DE",  # cyan
          "#9D66A7",  # magenta
          "#60CC9D",  # aquamarine
          "#6C66A6",  # purple
          "#FBB6AB",  # light coral
          "#FEEA9E",  # light yellow (sandy)
          "#AEC9E6",  # light blue
          "#91D34B",  # light green
          "#FCAC63",  # light orange
          "#AFDCEC",  # pale blue
          "#C3A2CA",  # pale purple
          "#9DE0C4",  # pale green-blue
          "#A9A5CB",  # pale purple-blue
          "#6F5F51",  # brown
          "#BCB8A8",  # silvery
          "#EFE8D3",  # white green
          ]


def Chart(workbook, type, subtype, title):
    # Create chart
    chart = workbook.add_chart({
        'type': type,
        'subtype': subtype})
    chart.set_size({'width': 900,
                    'height': 600})
    chart.set_chartarea({'border': {'none': True},
                         'fill': {'none': True}})
    chart.set_plotarea({'border': {'none': True},
                        'fill': {'none': True}})
    chart.set_x_axis({'num_font': {
        'size': 16,
        'bold': False,
        'name': FONT_NAME},
        'major_tick_mark': 'none',
        'minor_tick_mark': 'none',
        'line': {'none': True},
        'major_gridlines': {
            'visible': True,
            'line': {'width': 1.5,
                     'dash_type': 'solid',
                     'color': '#DdDdDd'}}})
    chart.set_y_axis({'num_font': {'size': 16,
                                   'bold': False,
                                   'name': FONT_NAME},
                      'name_font': {"size": 16, "bold": True, "name": FONT_NAME},
                      'major_tick_mark': 'none',
                      'minor_tick_mark': 'none',
                      'line': {'none': True}})
    chart.set_title({'name': title,
                     'name_font': {
                         'size': 20,
                         'bold': False,
                         'name': FONT_NAME}})
    chart.set_legend({
        'position': 'bottom',
        "font": {'size': 14,
                 'bold': False,
                 'name': FONT_NAME}})

    return chart


def chart_add_series(chart, num, opt):
    def_fmt = {
        "data_labels": {
            'value': True,
            'num_format': "### ### ### ### ##0",
            'font': {'size': 12,
                     'bold': False,
                     'name': "Textbook New"}},
        "fill": {"color": COLORS[num]}}
    # fixme(n-bar) добавить одбновление для опций произволной глубины
    if opt:
        for k in opt:
            if isinstance(opt[k], dict):
                def_fmt[k].update(opt[k])
            else:
                def_fmt[k] = opt[k]

    chart.add_series(def_fmt)
