# coding: utf-8
"""xlsx-reports: 12_group_stat_distribution"""
import pandas as pd
import seaborn as sns


def table_group_stat_distribution(df):

    df_chart = (df[["GroupID", "DirectPhraseID", "Shows", "Clicks", "Cost"]]
                .groupby("GroupID", as_index=False)
                .agg({"Shows": pd.np.sum,
                      "Clicks": pd.np.sum,
                      "Cost": pd.np.sum,
                      "DirectPhraseID": lambda x: x.unique().size})
                .groupby("DirectPhraseID")
                .sum()
                [["Shows", "Clicks", "Cost"]]
                .sort_index())
    df_chart.rename(columns={
        "Shows": u"Показы",
        "Clicks": u"Клики",
        "Cost": u"Затраты"},
        inplace=True)
    if df_chart.shape[0] == 0:
        return None
    df_chart.index.names = [u"Кол-во фраз в группе"]

    chart_group_stat_distribution(df_chart)

    return df_chart


def chart_group_stat_distribution(df_chart):
    """12_group_stat_distribution"""

    (df_chart.apply(lambda x: x / x.sum(), axis=0)
     .plot.bar(rot=0))
    sns.plt.suptitle(u"Фразы в группах", size=22)
    sns.plt.xlabel(u"Кол-во фраз", size=16)
    sns.plt.ylabel(u"Доля от общего", size=16)
    sns.plt.savefig("./charts/12_group_stat_distribution.png", dpi=200)
